"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeGenerator = void 0;
const fs = require("fs");
class CodeGenerator {
    #count = 0;
    #stream = 0;
    #indent = '';
    constructor() {
    }
    open(fpath, indent) {
        this.#count = 0;
        this.#stream = fs.openSync(fpath, "w");
        this.#indent = indent ? indent : '';
    }
    up(text) {
        this.push(text);
        this.#count++;
    }
    down(text) {
        this.#count--;
        this.push(text);
    }
    push(text) {
        const head = 0 < this.#count ? this.#indent.repeat(this.#count) : '';
        for (const l of text.split(/\r*\n/)) {
            fs.writeSync(this.#stream, `${head}${l}\n`);
        }
    }
    close() {
        fs.closeSync(this.#stream);
    }
}
exports.CodeGenerator = CodeGenerator;
