"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigLoader = void 0;
const fs = require("fs");
const path = require("path");
const tsConfig = 'rest-api-testing-codegen.config.ts';
const jsConfig = 'rest-api-testing-codegen.config.js';
class ConfigLoader {
    defaultConfig;
    loadedConfig;
    constructor(defaultConfig) {
        this.defaultConfig = defaultConfig;
        this.loadedConfig = {};
    }
    get config() {
        return Object.assign(this.defaultConfig, this.loadedConfig);
    }
    loadConfig(configFile) {
        if (fs.existsSync(configFile)) {
            if (process.stdout.isTTY)
                console.log(`Using config at ` + configFile);
            this.loadedConfig = this.loadConfigFile(configFile);
            return true;
        }
        return false;
    }
    loadConfigFromDirectory(directory) {
        const configNames = [jsConfig];
        for (const configName of configNames) {
            if (this.loadConfig(path.resolve(directory, configName)))
                return true;
        }
        return false;
    }
    loadConfigFile(file) {
        let config = require(file);
        if (config && typeof config === 'object' && ('default' in config))
            config = config['default'];
        const rawConfig = { ...config };
        return rawConfig;
    }
}
exports.ConfigLoader = ConfigLoader;
