"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JestExpectPattern = void 0;
const util_1 = require("./util");
class JestExpectPattern {
    #patterns = [];
    constructor() {
    }
    add(key, ptn) {
        this.#patterns.push([key, ptn]);
    }
    definelines() {
        const lines = [];
        for (const [key, ptn] of this.#patterns) {
            lines.push(`const expect_${key} = expect.stringMatching(${ptn});`);
        }
        return lines;
    }
    stringify(json, space) {
        space = space ? space : '';
        return (0, util_1.json_stringify)(json, space, 1, (val) => {
            for (const [key, ptn] of this.#patterns) {
                if (ptn.test && typeof val == 'string' && ptn.test(val)) {
                    return `expect_${key} /*${val}*/`;
                }
            }
            let type = typeof val;
            switch (type) {
                case 'number':
                case 'string':
                case 'boolean':
                    type = type[0].toUpperCase() + type.substring(1);
                    return `expect.any(${type}) /*${(val)}*/`;
            }
            return JSON.stringify(val);
        });
    }
}
exports.JestExpectPattern = JestExpectPattern;
